/* memoria.h */

#define OK     1
#define ERRO   0

#define FALSO      0
#define VERDADEIRO 1

typedef struct nodo {

  char far *cpz_entidade;

  int i_ind_arq_ind;

  int i_ind_arq_base;

  struct nodo far *proximo;

} far*ptr_nodo;

class memoria {

protected:

  ptr_nodo ptr_chaves;

  ptr_nodo busca;

  int i_num_chaves;

  int bate (char far *cpz_entidade, const char *cpz_inf_busca);

public:

  memoria (void);

  void insere_chave (const char *cpz_entidade, const int i_indice_ind,
		     const int i_indice_base);

  void retira_chave (const int i_indice_ind, const int i_indice_base);

  void prepara_busca (void) {

    busca = ptr_chaves;

  };

  int procura_chave (char *cpz_entidade, int &i_indice_ind,
		     int &i_indice_base, const char *cpz_inf_busca);

  void ordene (void);

  void liste_memoria (void);

  int num_registros (void);

  ~memoria (void);

};

